import { CryptoSession } from './session.js';
export interface SecureFetchOptions extends RequestInit {
    hostname?: string;
    fetcher?: (input: RequestInfo | URL, init?: RequestInit | undefined) => Promise<Response>;
}
export interface SecureBody {
    isEncoded: boolean;
    type: string;
    data: string;
    url: string;
}
export interface SecureResponse extends Response {
    data?: object | string;
    err?: any;
}
export declare class SecureFetch extends Function {
    readonly hostname: string;
    readonly session: CryptoSession;
    readonly fetcher: Function;
    readonly options: RequestInit;
    static generate(peerKey: string | Uint8Array, options?: SecureFetchOptions): SecureFetch;
    constructor(peerKey: string | Uint8Array, secretKey: string | Uint8Array, options?: SecureFetchOptions);
    getOptions(options?: RequestInit): RequestInit;
    getAuthHeaders(token: string, type?: string, options?: RequestInit): HeadersInit;
    fetch(path: RequestInfo | URL, options: SecureFetchOptions): Promise<SecureResponse>;
    get(path: string, options: RequestInit): Promise<SecureResponse>;
    post(path: string, options: RequestInit): Promise<SecureResponse>;
    handleResponse(res: SecureResponse): Promise<SecureResponse>;
}
//# sourceMappingURL=fetch.d.ts.map