import { CryptoSession } from './session.js';
import { Request, Response, NextFunction } from 'express';
declare global {
    namespace Express {
        interface Request {
            session: CryptoSession;
        }
        interface Response {
            secureSend: (payload: string, status?: number) => Promise<Response>;
            secureJson: (payload: object, status?: number) => Promise<Response>;
        }
    }
}
export interface SecureNextRequest {
    query: Partial<Record<string, string | string[]>>;
    cookies: Partial<Record<string, string>>;
    body: any;
    headers: Headers;
    method: string;
    url: string;
}
export interface SecureNextResponse {
    secureSend: (payload: string, status?: number) => void;
}
export declare function useAuthWithExpress(req: Request, res: Response, next: NextFunction): Promise<void | Response<any, Record<string, any>>>;
export declare function useAuthWithNext(handler: Function): unknown;
export declare function useCryptoAuth(req: Request, res: Response): Promise<void>;
//# sourceMappingURL=middleware.d.ts.map